/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.ColoniaDAO;
import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Colonia;

import java.util.List;

import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Order;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("coloniaDAO")
public class ColoniaHibernateDAO extends GenericHibernateDAO<Colonia, Integer>
        implements ColoniaDAO {

    @Autowired
    public ColoniaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Colonia> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("desccolonia"));

        return c.list();
    }

    public List<Colonia> buscar(String desccolonia) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("desccolonia", desccolonia));

        return c.list();
    }

    public List<Colonia> buscarPorCiudad(Ciudad ciudad) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("ciudad", ciudad));
        c.addOrder(Order.asc("desccolonia"));
        return c.list();
    }

	@Override
	public List<Colonia> buscaLike(String desccolonia) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.like("desccolonia", desccolonia, MatchMode.START));
		c.addOrder(Order.asc("desccolonia"));

		return c.list();
	}

	@Override
	public List<Colonia> buscarPorCodMun(Ciudad ciudad, String desccolonia) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("ciudad", ciudad));
		c.add(Restrictions.eq("desccolonia", desccolonia));
		return c.list();
	}
    
    
}
